using System.Text;
using JiShe.CollectBus.Common.Extensions;
using JiShe.CollectBus.Protocol.Contracts.Protocol.Dto;
using JiShe.CollectBus.Protocol.Dto;
using JiShe.CollectBus.Protocol.Interfaces;
using JiShe.CollectBus.Protocol3761;
using Microsoft.Extensions.Logging;

namespace JiShe.CollectBus.Protocol.AnalysisData.AFN_09H
{
    /// <summary>
    /// 5.9.1.2 F1:终端版本信息 
    /// </summary>
    public class AFN9_F1_Analysis : IAnalysisStrategy<TB3761>
    {
        private readonly ILogger<AFN9_F1_Analysis> _logger;

        public AFN9_F1_Analysis(ILogger<AFN9_F1_Analysis> logger)
        {
            _logger = logger;
        }

        public Task<bool> ExecuteAsync(TB3761 input, Action<dynamic>? result = null)
        {
            try
            {
                ArgumentNullException.ThrowIfNull(input);
                ArgumentNullException.ThrowIfNull(input.UnitData.HexMessageList);
                var data = AnalysisDataUnit(input.UnitData.HexMessageList);
                data.AreaCode = input.A.Code?.Substring(0, 4);
                data.Address = input.A.Code?.Substring(4, 5);
                UnitDataAnalysis<AFN9_F1_AnalysisDto> dto = new UnitDataAnalysis<AFN9_F1_AnalysisDto>
                {
                    Code = input.A.Code!,
                    AFN = input.AFN_FC.AFN,
                    Fn = input.DT.Fn,
                    Pn = input.DA.Pn,
                    Data = data,
                    HexMessage = input.BaseHexMessage.HexMessageString,
                    MessageId = input.MessageId,
                    ReceivedTime = input.ReceivedTime
                };
                result?.Invoke(dto);
                return Task.FromResult(true);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, $"09_1解析失败:{input.A?.Code}-{input.DT?.Fn ?? 0}-{input?.BaseHexMessage?.HexMessageString},{ex.Message}");
            }
            return Task.FromResult(false);
        }

        private AFN9_F1_AnalysisDto AnalysisDataUnit(List<string> hexMessageList)
        {
            AFN9_F1_AnalysisDto version = new AFN9_F1_AnalysisDto();
            version.MakerNo = Encoding.ASCII.GetString(string.Join("", hexMessageList.Skip(4).Take(4).ToList()).HexToByte());//厂商代号
            version.DeviceNo = Encoding.ASCII.GetString(string.Join("", hexMessageList.Skip(8).Take(8).ToList()).HexToByte()).Replace("\0", "");//设备编号
            version.SoftwareVersion = Encoding.ASCII.GetString(string.Join("", hexMessageList.Skip(16).Take(4).ToList()).HexToByte());//终端软件版本号
            version.HardwareVersion = Encoding.ASCII.GetString(string.Join("", hexMessageList.Skip(38).Take(4).ToList()).HexToByte());//终端硬件版本号
            version.AddDate = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");
            var dateArr = hexMessageList.Skip(20).Take(3).ToList();
            var dateArr2 = hexMessageList.Skip(42).Take(3).ToList();
            dateArr.Reverse();
            dateArr2.Reverse();
            version.SoftwareReleaseDate = $"{DateTime.Now.Year.ToString().Substring(0, 2)}{string.Join("-", dateArr)}";//终端软件发布日期：日月年
            version.HardwareReleaseDate = $"{DateTime.Now.Year.ToString().Substring(0, 2)}{string.Join("-", dateArr2)}";//终端硬件发布日期：日月年
            return version;
        }
    }
}
